<?php
class FP_UD {
	function array_merge_recursive_distinct () {
	  $arrays = func_get_args();
	  $base = array_shift($arrays);
	  if(!is_array($base)) $base = empty($base) ? array() : array($base);
	  foreach($arrays as $append) {
		if(!is_array($append)) $append = array($append);
		foreach($append as $key => $value) {
		  if(!array_key_exists($key, $base) and !is_numeric($key)) {
			$base[$key] = $append[$key];
			continue;
		  }
		  if(is_array($value) or is_array($base[$key])) {
			$base[$key] = FP_UD::array_merge_recursive_distinct($base[$key], $append[$key]);
		  } else if(is_numeric($key)) {
			if(!in_array($value, $base)) $base[] = $value;
		  } else {
			$base[$key] = $value;
		  }
		}
	  }
	  return $base;
	}
	
	function array_copy($aSource) {
        if (!is_array($aSource)) {
            throw new Exception("Input is not an Array");
        }
        $aRetAr = array();
        $aKeys = array_keys($aSource);
        $aVals = array_values($aSource);
        for ($x=0;$x<count($aKeys);$x++) {
            if (is_object($aVals[$x])) {
                $aRetAr[$aKeys[$x]]=clone $aVals[$x];
            } elseif (is_array($aVals[$x])) {
                $aRetAr[$aKeys[$x]]= FP_UD::array_copy ($aVals[$x]);
            } else {
                $aRetAr[$aKeys[$x]]=$aVals[$x];
            }
        }
        return $aRetAr;
    }
	
	function base_url($page = '') {
	
		$permalink = get_option('permalink_structure');

	 
		if ( '' != $permalink) {
			$permalink = home_url( $page);
			$permalink = user_trailingslashit($permalink);
		
		} else {
		$permalink = home_url('?p=' . $page);
		
		}
		
		return $permalink;
		
	}
	
	function add_cache($id = false, $type = false, $data = false) {
		global $wpdb;
		
		if(!is_numeric($id))
			return false;
			
		if(empty($data))
			return false;

		if(empty($type))
			return false;
		
		$tablename = $wpdb->prefix . "fp_ud_cache";
		


		// Check if table exists
		if(UD_F::check_cache_table()) {
	 
			// Remove old cahce
			$wpdb->query("DELETE FROM $tablename WHERE id = '$id'");
			
			
			if(!$wpdb->insert($tablename, array('id' => $id, 'type' => $type, 'data' => serialize($data))))
				return false;
			
			
			return true;
		}
		
		return false;
		
	}
	
 	/**
	 * Gets cache if it exists
	 * 
	 * Creates cache tables if not created, and adds an object
	 * 
	 *
	 * @version 1.4
	**/
	function get_cache($id = false) {
		global $wpdb;
		
		if(!is_numeric($id))
			return false;
			
 		
		$tablename = $wpdb->prefix . "fp_ud_cache";
	
		// Check if table exists
		if(!UD_F::check_cache_table())
			return;

		$data = $wpdb->get_var("SELECT data FROM $tablename WHERE id = '$id'");
		
		$data = unserialize($data);
		
		if(is_array($data))
			return $data;
			
			
		return false;
		
	}
	
 
	
		
	/**
	 * Checks if a database table exists, if not, create it
	 * 
	 *
	 * @version 1.4
	**/
	function check_cache_table($table_name = 'fp_ud_cache') {
		global $wpdb;
		
		// Get tablename
		$table_name = $wpdb->prefix . $table_name;
		
		// If table already exists do nothing
		if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") == $table_name)
			return true;

		// Table does not exist, make it		
		$sql = "CREATE TABLE " . $table_name . " (
			  id bigint(20) NOT NULL,
			  type varchar(200) NOT NULL DEFAULT '',
			  data text NOT NULL,
			  modified TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP
			);";

		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);

				
		// Verify it exists
		if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") == $table_name) {
			return true;
		}
		
		// Something went terribly wrong
		return false;
		
	}
 

 	/**
	 * Returns a URL to a post object based on passed variable.
	 *
	 * If its a number, then assumes its the id, If it resembles a slug, then get the first slug match.
	 *
	 * @since 1.0 
	 * @param string $title A page title, although ID integer can be passed as well
	 * @return string The page's URL if found, otherwise the general blog URL
	 */
	function post_link($title = false) {
		global $wpdb;
		
		if(!$title)
			return get_bloginfo('url');
		
		if(is_numeric($title))
			return get_permalink($title);

        if($id = $wpdb->get_var("SELECT ID FROM $wpdb->posts WHERE post_name = '$title'  AND post_status='publish'"))
			return get_permalink($id);

		if($id = $wpdb->get_var("SELECT ID FROM $wpdb->posts WHERE LOWER(post_title) = '".strtolower($title)."'   AND post_status='publish'"))
			return get_permalink($id);
				
	}
	
	
	function checkbox($args = '', $checked = false) {
		$defaults = array('name' => '', 'id' => false,'class' => false, 'group' => false,'special' => '','value' => 'true', 'label' => false, 'maxlength' => false);
		extract( wp_parse_args( $args, $defaults ), EXTR_SKIP );
		
		// Get rid of all brackets
		if(strpos("$name",'[') || strpos("$name",']')) {
			$replace_variables = array('][',']','[');
			$class_from_name = $name;
			$class_from_name = UD_PREFIX . str_replace($replace_variables, '_', $class_from_name);
		} else {
			$class_from_name = UD_PREFIX . $name;	
		}
		
		
		// Setup Group
		if($group) {
			if(strpos($group,'|')) {
				$group_array = explode("|", $group);
				$count = 0;
				foreach($group_array as $group_member) {
					$count++;
					if($count == 1) {
						$group_string .= "$group_member";
					} else {
						$group_string .= "[$group_member]";
					}
				}
			} else {
				$group_string = "$group";
			}
		}
		

		// Use $checked to determine if we should check the box
		$checked = strtolower($checked);
		if($checked == 'yes') 	$checked = 'true'; 
		if($checked == 'true') 	$checked = 'true'; 
		if($checked == 'no') 	$checked = false;
		if($checked == 'false') $checked = false; 
		
 		
		$id					= 	($id ? $id : $class_from_name);
		
		$insert_id 			= 	($id ? " id='$id' " : " id='$class_from_name' ");
		$insert_name		= 	($group_string ? " name='".$group_string."[$name]' " : " name='$name' ");
		$insert_checked		= 	($checked ? " checked='checked' " : " ");
		$insert_value		= 	" value=\"$value\" ";
		$insert_class 		= 	" class='$class_from_name $class ".UD_PREFIX."checkbox " . ($group ? UD_PREFIX . $group . '_checkbox' : ''). "' ";
		$insert_maxlength	= 	($maxlength ? " maxlength='$maxlength' " : " ");

		// Determine oppositve value
		switch ($value) {
			case 'yes':
			$opposite_value = 'no';
			break;

			case 'true':
			$opposite_value = 'false';
			break;
		
		}
		
		// Print label if one is set
		if($label) $return .= "<label for='$id'>";
		
		// Print hidden checkbox
		$return .= "<input type='hidden' value='$opposite_value' $insert_name />";
		
		// Print checkbox
		$return .= "<input type='checkbox' $insert_name $insert_id $insert_class $insert_checked $insert_maxlength  $insert_value $special />";
		if($label) $return .= " $label</label>";	
		
		return $return;
	}
	

	/**
	 * Shorthand function for drawing a textarea
	 *
	 *
	 * @since 1.0
	 * @uses wp_parse_args() Creates an array from string $args.
	 * @link http://usabilitydynamics/codex/UD_UI/input
	 *
	 * @param string $args List of arguments to overwrite the defaults.
 	 * @return string Input field and hidden field with the opposive value
	 */
	 
	function textarea($args = '') {
		$defaults = array('name' => '', 'id' => false,  'checked' => false,  'class' => false, 'style' => false, 'group' => '','special' => '','value' => '', 'label' => false, 'maxlength' => false);
		extract( wp_parse_args( $args, $defaults ), EXTR_SKIP );
	
	  
		// Get rid of all brackets
		if(strpos("$name",'[') || strpos("$name",']')) {
			$replace_variables = array('][',']','[');
			$class_from_name = $name;
			$class_from_name = UD_PREFIX . str_replace($replace_variables, '_', $class_from_name);
		} else {
			$class_from_name = UD_PREFIX . $name;	
		}
		
		
		// Setup Group
		if($group) {
			if(strpos($group,'|')) {
				$group_array = explode("|", $group);
				$count = 0;
				foreach($group_array as $group_member) {
					$count++;
					if($count == 1) {
						$group_string .= "$group_member";
					} else {
						$group_string .= "[$group_member]";
					}
				}
			} else {
				$group_string = "$group";
			}
		}
		
		$id					= 	($id ? $id : $class_from_name);
		
		$insert_id 			= 	($id ? " id='$id' " : " id='$class_from_name' ");
		$insert_name		= 	($group_string ? " name='".$group_string."[$name]' " : " name=' ".UD_PREFIX."$name' ");
		$insert_checked		= 	($checked ? " checked='true' " : " ");
		$insert_style		= 	($style ? " style='$style' " : " ");
		$insert_value		= 	($value ? $value : "");
		$insert_class 		= 	" class='$class_from_name input_textarea $class' ";
		$insert_maxlength	= 	($maxlength ? " maxlength='$maxlength' " : " ");
	
		// Print label if one is set
		
		// Print checkbox
		$return .= "<textarea $insert_name $insert_id $insert_class $insert_checked $insert_maxlength $special $insert_style>$insert_value</textarea>";
		
		
		return $return;
	}
	

	/**
	 * Shorthand function for drawing regular or hidden input fields.
	 *
	 * Returns an input field using the plugin-specific prefix.  
	 *
	 * The list of input field arguments are 'name', 'group', 'special','value', 'type', 'hidden', 'style', 'readonly', and 'label'.
	 *
	 * List of default arguments are as follows:
	 * 'hidden' - False
	 * 'style' - False
	 * 'readonly' - False
	 * 'label' - False
	 *
	 * @since 1.3
	 * @uses wp_parse_args() Creates an array from string $args.
	 * @link http://usabilitydynamics/codex/UD_UI/input
	 *
	 * @param string $args List of arguments to overwrite the defaults.
	 * @param string $value Value may be passed in arg array or seperately
 	 * @return string Input field and hidden field with the opposive value
	 */
	function input($args = '', $value = false) {
		$defaults = array('name' => '', 'group' => '','special' => '','value' => $value, 'type' => 'text', 'class' => false, 'hidden' => false, 'style' => false, 'readonly' => false, 'label' => false);
		extract( wp_parse_args( $args, $defaults ), EXTR_SKIP );
		
		// Add prefix
		//$name = UD_PREFIX . "$name";
		
		if($class)
			$class = UD_PREFIX . "$class";
		
		
		// if [ character is present, we do not use the name in class and id field
		if(!strpos("$name",'[')) {
			$id = $name;
			$class_from_name = $name;
		}
		
		if($label) $return .= "<label for='$name'>";
		$return .= "<input ".($type ?  "type=\"$type\" " : '')." ".($style ?  "style=\"$style\" " : '')." id=\"$id\" class=\"".($type ?  "" : "input_field")." $class_from_name $class ".($hidden ?  " hidden " : '').""  .($group ? "group_$group" : ''). " \"  	name=\"" .($group ? $group."[".$name."]" : $name). "\" 	value=\"".stripslashes($value)."\" 	title=\"$title\" $special ".($type == 'forget' ?  " autocomplete='off'" : '')." ".($readonly ?  " readonly=\"readonly\" " : "")." />";		
		if($label) $return .= " $label </label>";

		return $return;
	}
}
?>