<?php
class FP_API {
	function FP_API() {
		add_action("after_setup_theme", array('FP_Core', "after_setup_theme"));	
		add_filter("fp_stat_filter_price", array('FP_API', 'add_dollar_sign'));
		add_filter("fp_stat_filter_area", array('FP_API', 'add_square_foot'));
		
		add_filter("fp_stat_filter_floorplan_type", array('FP_API', 'get_floorplan_type'));
		add_filter("fp_stat_filter_floorplan_collection", array('FP_API', 'get_floorplan_collection'));
		add_filter("fp_stat_filter_garage_location", 'ucwords');
		add_filter("fp_stat_filter_first_floor_master_suite", array('FP_API', 'binary_to_word'));
		add_filter("fp_stat_filter_third_floor", array('FP_API', 'binary_to_word'));
		add_filter("fp_stat_filter_sideload_garage", array('FP_API', 'binary_to_word'));
		
		add_filter("fp_stat_filter_range_plus", array('FP_API', 'add_range_plus'));
	}
	
	function format_phone_number($phone_number) {	
		$phone_number = ereg_replace("[^0-9]",'',$phone_number);
		if(strlen($phone_number) != 10) return(False);
		$sArea = substr($phone_number,0,3);
		$sPrefix = substr($phone_number,3,3);
		$sNumber = substr($phone_number,6,4);
		$phone_number = "(".$sArea.") ".$sPrefix."-".$sNumber; 
		return $phone_number;
	}
	
	function get_floorplan_type($num) {
		global $floorplans;
		return $floorplans['floorplan_type'][$num];
	}
	
	function get_floorplan_collection($num) {
		global $floorplans;
		//return 'test';
		return $floorplans['floorplan_collection'][$num];
	}
		
	function add_square_foot($area) {
		return $area . " sq.ft";
	}
	
	function binary_to_word($num) {
		if ($num == 1) return __('Yes', 'floorplans');
		else return __('No', 'floorplans');
	}
	
	function add_dollar_sign($content) {
		global $floorplans;
		return $floorplans['configuration']['currency_symbol'] . $content;
	}	
	
	function add_range_plus($content) {
		return (int)$content . '+';
	}
}
?>