<?php
/**
 * WP-floorplan Overview Template
 *
 * To customize this file, copy it into your theme directory, and the plugin will
 * automatically load your version.
 *
 * You can also customize it based on floorplan type.  For example, to create a custom
 * overview page for 'building' floorplan type, create a file called floorplan-overview-building.php
 * into your theme directory.
 *
 *
 * Settings passed via shortcode:
 * $floorplans: either array of floorplans or false
 * $show_children: default true
 * $thumbnail_size: slug of thumbnail to use for overview page
 * $thumbnail_sizes: array of image dimensions for the thumbnail_size type
 * $fancybox_preview: default loaded from configuration
 * $child_floorplans_title: default "Floor plans at location:"
 *
 *
 *
 * @version 1.4
 * @author Andy Potanin <andy.potnain@twincitiestech.com>
 * @package WP-floorplan
*/
$thumbnail_size = 'thumbnail';
if($floorplan_objects): ?>
	
    <div class="fp_row_view">
<div class="all-floorplans" id="all-floorplan-overview">

    <?php
    unset($floorplan_objects['total']); // VERY IMPORTANT!!!
	$skip_stats = array('video_code');
    foreach($floorplan_objects as $floorplan_id):
        // Get floorplan array/object and run it through prepare_floorplan_for_display(), which runs all filters
        $floorplan = prepare_floorplan_for_display(get_floorplan($floorplan_id, "get_floorplan['children']={$show_floorplan['children']}"));
        // Configure variables
        if($fancybox_preview) {
            $thumbnail_link = $floorplan['featured_image_url'];
            $link_class = 'fancybox_image';
        } else {
            $thumbnail_link = $floorplan['permalink'];
        }
		//print_r($floorplan);
      ?>

    <div class="floorplan_div <?php echo $floorplan['post_type']; ?> clearfix">

        <div class="fp_overview_left_column">

           <!-- <div class="floorplan_image">-->
                <a href="<?php echo $floorplan['permalink']; ?>" title="<?php echo $floorplan['post_title'] . ($floorplan['parent_title'] ? " of " . $floorplan[parent_title] : "");?>"  class="floorplan_overview_thumb floorplan_overview_thumb_<?php echo $thumbnail_size; ?> <?php echo $link_class; ?>" rel="floorplans" >
                    <img src="<?php echo $floorplan['images'][$thumbnail_size]; ?>" alt="<?php echo $floorplan['post_title'];?>" />
                </a>
            <!--</div>--><br />
			<a href="<?php echo $floorplan['permalink']; ?>"><?php echo $floorplan['post_title']; ?></a>
        </div><?php // .fp_overview_left_column ?>

        <div class="fp_overview_right_column" style="margin-left:<?php echo 165; ?>px; width:80%;">
			<table cellpadding="0" cellpadding="0" class="floorplans_overview_table">
                <thead>
                    <tr>
                    	<?php foreach ($floorplans['floorplan_overview_cols'] as $key => $stat) {
								if (in_array($key, $skip_stats)) continue;
						?>
                        <th scope="col"><?php echo $stat; ?></th>
                        <?php } ?>
                    </tr>
                </thead>
                <tbody>
                	<tr>
                		<?php foreach ($floorplans['floorplan_overview_cols'] as $stat_key => $stat) {
								if (in_array($stat_key, $skip_stats)) continue;
						?>
                        <td>
						<?php
							switch($stat_key) {
								case 'floorplan_type':
									$type_id = (!empty($floorplan[$stat_key])) ? $floorplan[$stat_key] : 0;
									echo $floorplan[$stat_key];
								break;
								default:
                       				echo $floorplan[$stat_key];
								break;
							}
						?>
                        </td>
                        <?php } ?>
                	</tr>
                </tbody>
                
            </table>
            <?php echo $floorplan['post_excerpt']; ?>
        </div><?php // .fp_right_column ?>

    </div><?php // .floorplan_div ?>

    <?php endforeach; ?>
    </div><?php // .fp_row_view ?>
	</div>
<?php else: ?>
<div class="fp_nothing_found">
   <?php echo sprintf(__('Sorry, no floorplans found - try expanding your search, or <a href="%s">view all</a>.','floorplans'), site_url().'/'.$floorplans['configuration']['base_slug']); ?>
</div>
<?php endif; ?>